[Setup]
MinVersion=4.0,4.0

AppName=ConTEXT v0.98.6
AppVerName=ConTEXT
AppID=ConTEXTEditor

; w2k info
AppPublisher=ConTEXT Project Ltd
AppPublisherURL=http://www.contexteditor.org
AppSupportURL=http://www.contexteditor.org
AppUpdatesURL=http://www.contexteditor.org
AppVersion=0.98.6

AllowNoIcons=0
AppCopyright=Copyright  2000-2009. ConTEXT Project Ltd
AppMutex=ConTEXTEditorMutex
BackColor=$FF0000
BackSolid=0
Compression=bzip/9
CreateAppDir=1
DefaultDirName={pf}\ConTEXT
DefaultGroupName=ConTEXT
DisableDirPage=0
DisableProgramGroupPage=0
DisableStartupPrompt=1
DisableFinishedPage=1
DiskSpanning=0
OutputBaseFilename="ConTEXTv0_986"
OutputDir=\ConTEXT\ConTEXT\Install\
SourceDir=\ConTEXT\ConTEXT\
Uninstallable=1
ChangesAssociations=1
WizardImageFile=res\InstallWizConTEXT.bmp
WizardSmallImageFile=res\InstallWizConTEXTSmall.bmp

[Dirs]
Name: {app}\Language
Name: {app}\Backup
Name: {app}\Template
Name: {app}\Highlighters

[Types]
Name: "full"; Description: "Full installation"
Name: "custom"; Description: "Custom installation"; Flags: iscustom

[Components]
Name: "main"; Description: "Main files"; Types: full;
Name: "languagefiles"; Description: "Language files"; Types: full custom;
Name: "codetemplates"; Description: "Code templates"; Types: full custom;

[Tasks]
Name: taskDesktopIcon; Description: "Create a &desktop icon"; GroupDescription: "Additional icons:"; Components: main;
Name: taskQuickLaunchIcon; Description: "Create a &Quick Launch icon"; GroupDescription: "Additional icons:"; Components: main;
Name: taskReplaceNotepad; Description: "Replace Windows &Notepad"; GroupDescription: "Automated tasks:"; Components: main; Flags: unchecked
Name: taskViewHistoryReadme; Description: "View &ReadMe and History"; GroupDescription: "Misc:"; Components: main;
Name: taskVisitWeb; Description: "Visit ConTEXT Website"; GroupDescription: "Misc:"; Components: main;

[Files]
Source: ConTEXT.exe; DestDir: {app}\; DestName: ConTEXT.exe; Components: main;
Source: ConTEXT.hlp; DestDir: {app}\; DestName: ConTEXT.hlp; Components: main;
Source: ConTEXT.cnt; DestDir: {app}\; DestName: ConTEXT.cnt; Components: main;
Source: install\History.txt; DestDir: {app}\; DestName: History.txt; Components: main;
Source: install\ReadMe.txt; DestDir: {app}\; DestName: ReadMe.txt; Components: main;
Source: Notepad replacement\Notepad.exe; DestDir: {app}\; DestName: Notepad.exe; Components: main;
Source: ConExec\ConExec.exe; DestDir: {app}\; DestName: ConExec.exe; Components: main;
Source: Language\Custom.lng; DestDir: {app}\Language\; Components: main;
Source: install\Highlighters\*.chl; DestDir: {app}\Highlighters\; Components: main;
Source: ReplaceNotepad\ReplaceNotepad.exe; DestDir: {app}\; DestName: ReplaceNotepad.exe; Components: main;
Source: Language\*.lng; DestDir: {app}\Language\; Components: languagefiles;
Source: install\Template\*.ctpl; DestDir: {app}\Template\; Flags: ConfirmOverwrite; Components: codetemplates

[Icons]
Name: {group}\ConTEXT; Filename: {app}\ConTEXT.exe; WorkingDir: {app}; IconIndex: 0
Name: {sendto}\ConTEXT; Filename: {app}\ConTEXT.exe; WorkingDir: {app}; IconIndex: 0
Name: {group}\Version History; Filename: {app}\History.txt; WorkingDir: {app}; IconIndex: 0
Name: {group}\ReadMe First; Filename: {app}\ReadMe.txt; WorkingDir: {app}; IconIndex: 0
Name: {userdesktop}\ConTEXT; Filename: {app}\ConTEXT.exe; WorkingDir: {app}; IconIndex: 0; Tasks: taskDesktopIcon;
Name: "{userappdata}\Microsoft\Internet Explorer\Quick Launch\ConTEXT"; Filename: {app}\ConTEXT.exe; WorkingDir: {app}; IconIndex: 0; Tasks: taskQuickLaunchIcon;
Name: {group}\Uninstall ConTEXT; Filename: {uninstallexe}

[INI]

[Registry]
Root: HKLM; SubKey: SOFTWARE\Microsoft\Windows\CurrentVersion\App Paths\ConTEXT.exe; ValueType: STRING; ValueData: {app}\ConTEXT.exe; Flags: uninsdeletekey
Root: HKCR; SubKey: .htm\OpenWithList\ConTEXT\shell\Edit\command; ValueType: STRING; ValueData: "{app}\ConTEXT.exe ""%1"""; Flags: uninsdeletekey
Root: HKCR; SubKey: .html\OpenWithList\ConTEXT\shell\Edit\command; ValueType: STRING; ValueData: "{app}\ConTEXT.exe ""%1"""; Flags: uninsdeletekey
Root: HKCR; SubKey: .cpr; ValueType: STRING; ValueData: ConTEXT Project; Flags: uninsdeletekey
Root: HKCR; SubKey: ConTEXT Project; ValueType: STRING; ValueData: ConTEXT Project; Flags: uninsdeletekey
Root: HKCR; SubKey: ConTEXT Project\DefaultIcon; ValueType: STRING; ValueData: {app}\ConTEXT.exe,2; Flags: uninsdeletekey
Root: HKCR; SubKey: ConTEXT Project\Shell\Open\Command; ValueType: STRING; ValueData: "{app}\ConTEXT.exe ""%1"""; Flags: uninsdeletekey
Root: HKLM; SubKey: SOFTWARE\Classes\.cpr; ValueType: STRING; ValueData: ConTEXT Project; Flags: uninsdeletekey
Root: HKLM; SubKey: SOFTWARE\Classes\ConTEXT Project; ValueType: STRING; ValueData: ConTEXT Project; Flags: uninsdeletekey
Root: HKLM; SubKey: SOFTWARE\Classes\ConTEXT Project\DefaultIcon; ValueType: STRING; ValueData: {app}\ConTEXT.exe,2; Flags: uninsdeletekey
Root: HKLM; SubKey: SOFTWARE\Classes\ConTEXT Project\Shell\Open\Command; ValueType: STRING; ValueData: "{app}\ConTEXT.exe ""%1"""; Flags: uninsdeletekey

[UninstallDelete]
Name: ConTEXT.fts; Type: files;
Name: ConTEXT.gid; Type: files;

[InstallDelete]
Name: "{app}\Language\Danish.lng"; Type: files;

[Run]
Filename: "{app}\ReplaceNotepad.exe"; Tasks: taskReplaceNotepad; Flags: runminimized;
Filename: "{app}\ConTEXT.exe"; Parameters: """{app}\ReadMe.txt"" ""{app}\History.txt"""; Tasks: taskViewHistoryReadme; Flags: nowait
Filename: "http://www.contexteditor.org"; Tasks: taskVisitWeb; Flags: nowait shellexec

[UninstallRun]
