program SyncLanguage;

uses
  Classes, SysUtils, IniFiles;

const
  TEMPLATE_FNAME = 'custom.lng';
  LOG_FNAME      = 'SyncLanguage.log';

var
  StartDir    :string;
  strTemplate :TStringList;
  strFiles    :TStringList;
  strLog      :TStringList;

//------------------------------------------------------------------------------------------
procedure EnumFiles(var str:TStringList);
var
  rec    :TSearchRec;
  found  :boolean;
begin
  str:=TStringList.Create;

  found:=FindFirst('*.lng',faAnyFile,rec)=0;

  repeat
    if found and (LowerCase(rec.Name)<>TEMPLATE_FNAME) then begin
      str.Add(StartDir+rec.Name);
    end;

    found:=FindNext(rec)=0;
  until not found;

  FindClose(rec);
end;
//------------------------------------------------------------------------------------------
procedure SyncFile(Src,Dest:string);
var
  srcF    :TIniFile;
  destF   :TIniFile;
  strSect :TStringList;
  i       :integer;

  procedure SyncSect(sect:string);
  var
    strSrcKeys  :TStringList;
    strDestKeys :TStringList;
    i           :integer;
    s           :string;
    sect_added  :boolean;
  begin
    sect_added:=FALSE;
    strSrcKeys:=TStringList.Create;
    strDestKeys:=TStringList.Create;

    srcF.ReadSection(sect,strSrcKeys);
    destF.ReadSection(sect,strDestKeys);

    // dodaj to nedostaje
    for i:=0 to strSrcKeys.Count-1 do begin
      if (strDestKeys.IndexOf(strSrcKeys[i])=-1) then begin
        if not sect_added then begin
          strLog.Add('['+sect+']');
          sect_added:=TRUE;
        end;

        s:=srcF.ReadString(sect,strSrcKeys[i],'');
        destF.WriteString(sect,strSrcKeys[i],'"'+s+'"');
        strLog.Add('  + '+strSrcKeys[i]+'="'+s+'"');
      end;
    end;

    // izbaci viak
    for i:=0 to strDestKeys.Count-1 do begin
      if (strSrcKeys.IndexOf(strDestKeys[i])=-1) then begin
        if not sect_added then begin
          strLog.Add('['+sect+']');
          sect_added:=TRUE;
        end;

        destF.DeleteKey(sect,strDestKeys[i]);
        strLog.Add('  - '+strDestKeys[i]);
      end;
    end;

    strSrcKeys.Free;
    strDestKeys.Free;
  end;

begin
  strLog.Add('');
  strLog.Add('### '+ExtractFileName(Dest));

  srcF:=TIniFile.Create(Src);
  destF:=TIniFile.Create(Dest);
  strSect:=TStringList.Create;

  srcF.ReadSections(strSect);

  for i:=0 to strSect.Count-1 do begin
    SyncSect(strSect[i]);
  end;

  destF.Free;
  srcF.Free;
end;
//------------------------------------------------------------------------------------------

var
  i :integer;

begin
  StartDir:=ExtractFilePath(ParamStr(0));
  strLog:=TStringList.Create;

  EnumFiles(strFiles);

  for i:=0 to strFiles.Count-1 do
    SyncFile(StartDir+TEMPLATE_FNAME,strFiles[i]);


  strLog.SaveToFile(LOG_FNAME);
  strLog.Free;
  
  strFiles.Free;
end.

